#pragma once
#include <string>
#include <map>
#include "CivSimuResStruct.h"

#define SIMULABSEXPORT __declspec(dllexport)
class CivConnection;

/**
 ģ
*/
class SIMULABSEXPORT CivSimulResHelperAbs
{
public:
	explicit CivSimulResHelperAbs();
	virtual ~CivSimulResHelperAbs();


	virtual bool beginTransaction();
	virtual bool commitTransaction();
	virtual bool insertNodes(const NodeResultItems& nodeitems);
	virtual bool insertLinks(const LinkResultItems& linkMap);
	virtual bool insertTanks(const TankResultItems& tankMap);
	virtual bool insertLinksBulk(const std::map<int, LinkResultItems>& linksMap);
	virtual bool insertNodeBulk(const std::map<int, TankResultItems>& nodesMap);
	virtual void getAllNodeCoords(NodeCoords& nodeCoords);
	virtual void getAllPipeCoords(PipeCoords& pipeCoords);
	virtual void getLinCodeSnMap(std::map<std::string, std::string>& map);
	virtual void getNodeCodeSnMap(std::map<std::string, std::string>& map);

protected:
	CivConnection* mConn = nullptr;
};